;(function() {

    // main
    var E = window.ESHA,
        R = E.recipe = {services: {}};

    // constants
    R.PUBLIC = {
        //TODO: default to standard api once enabled there!
        API: E.PUBLIC.TEST_API+'/recipe',
        TEST_API: E.PUBLIC.TEST_API+'/recipe',
        SERVICES: '/'
    };

    // config
    E.config('recipe', {
        key: E.util.setting('recipe.key'),
        api: E.util.setting('recipe.api', R.PUBLIC.API),
        services: E.util.setting('recipe.services', R.PUBLIC.SERVICES)
    });
    R.config = function(key, value) {
        return E.config('recipe.'+key, value);
    };

    // remote resources
    var isLoaded = E.isLoaded,
        loadServices = E.loadServices,
        key = E.key;
    E.isLoaded = function() {
        return isLoaded() && !!R.services;
    };
    E.loadServices = function() {
        loadServices();
        E.load(R.url(R.config('services')), function(services) {
            R.services = services;
        }, 'recipe load');
    };
    E.key = function(url, source) {
        // return the configured recipe key when talking to the public recipe api(s)
        if (url && source && source.indexOf('recipe') === 0 &&
            url.indexOf(R.PUBLIC.API) === 0 || url.indexOf(R.PUBLIC.TEST_API) === 0) {
            return R.config('key');
        }
        return key(url);
    };
    R.url = function(service) {
        service = R.services[service] || service;
        return R.config('api') + service;
    };

    R.foods = function(query, success) {
        var data = typeof query === "string" ? { query: query } : query,
            opts = E.util.isFunction(success) ? { success: success } : success || {};
        opts.data = data;
        opts.url = R.url('foods');
        success = opts.success || function(){};
        opts.success = function(search, o) {
            //for each item in recipe, enhance results
            for (var i=0; i<search.results.length; i++) {
                E.foods.enhance(search.results[i], opts);
            }
            success(search, o);
        };
        return E.util.request(opts, 'recipe foods');
    };

    R.analysis = function(query, success) {
        var data = typeof query === "string" ? { query: query } : query,
            opts = E.util.isFunction(success) ? { success: success } : success;
        opts.data = data;
        opts.data.s = data.s || data.servings || 1;
        opts.data.n = E.analysis.nParam(data.nutrients || config.nutrients);
        opts.url = R.url('analysis');
        success = opts.success;
        opts.success = function(analysis, o) {
            E.analysis.enhance(analysis);
            // enhance each recipe item
            for (var i=0, m=analysis.items.length; i<m; i++) {
                var item = analysis.items[i];
                if (item.total > 0) {
                    E.foods.enhanceItem(item);
                }
            }
            success(analysis, o);
        };
        return E.util.request(opts, 'recipe analysis');
    };

    R.save = function(recipe, later) {
        var params = E.foodlist.asData(recipe),
            url = R.url('verify'),
            key = E.key(url, 'recipe save');
        if (key) params.apikey = key;
        params.text = recipe.text;
        url = E.util.setParams(url, params);
        return later ? url : window.location = url;
    };

    R.track = function(params) {
        params.client = E.config('client');
        if ('jQuery' in window) {
            //TODO? switch to post-entity instead of url params
            jQuery.post(E.util.setParams(R.url('track'), params));
        }
    };

})();